# SD Tooling Deploy Instructions

## Description

The SD Tooling Application is composed by following modules

- **SIMPL SD UI**: Web Application that allows users to generate self-descriptions
- **SD-Tooling-Api-Be**: this is a microservices application that expose on Internet API to SIMPL SD UI
- **SD-Tooling-Api-Validation**: this is a microservice application that expose api validation of self-description to **SD-Tooling-Api-Be** component. So this component may not be exposed on Internet by Ingress

Currently On Dev Environment application is reachable through following URL: *https://sd-ui.dev.simpl-europe.eu/*

## Pre-requisite:

- Availability of NFS Storage to put schema files read by **SD-Tooling-API-BE**. Currently, in dev environment this storage is visible on namespace **gaiax-edc-dev-sd**. If you launch command __kubectl get pv__ you can see ID of the volume linked to NFS OVH resource. The NFS Storage (RWX) of 1Gb is needed and must be created by **DevSecOps** team. This storage is necessary because when **SD-Tooling-API-BE** starts it loads by storage schema files to generate list of offers displayed within the front-end component. **SIMPL SD UI**.
- Once NFS storage is created it's necessary create PersistentVolumeClaims linked to PersistentVolume created. .
- Availability of component **Web Storage** to host Contract Template mock files. **This component is part of setup of Catalogue components, so that this step can be executed during setup of XSFC Catalogue.** 
- After **Web Storage** component is available is necessary to upload the files (that are inside the GitLab folder **contractTemplates** on *https://code.europa.eu/simpl/simpl-open/development/data1/sdtooling-api-be* project) on the Web Server in order to make available those by URL exposed on Internet. Following an example of URL for one of this files: *https://files.dev.simpl-europe.eu/static/pdf/ContractTemplate1.pdf*. **This component is part of setup of Catalogue components, so that this step can be executed during setup of XSFC Catalogue**
- Tier1 gateway installed and configured for the Participant provider (see 'Tier1 gateway installation'): sd-tooling-be must be protected by the gateway and must not be reached directly from a public address.
  
## Tier1 Cloud Gateway Installation
To install all required Tier1 components follow the last guide version, for a participant provider, in the section 'IAA components installation doc' here: https://code.europa.eu/simpl/simpl-open/development/iaa/charts/-/tree/develop.
In your Cloud Gateway values.yaml add a new springRoutes for the sd-tooling-be service, example:

```yaml
springRoutes:
  - id: keycloak
    uri: ${keycloak.url}
    predicates:
      - Path=/auth/**
    filters:
      - StripPrefix=1
  - id: users-roles
    uri: ${users-roles.url}
    predicates:
      - Path=/*/user-api/**
    filters:
      - StripPrefix=2
  # sd-tooling-be route as configured in our dev env
  # change the uri replacing your namespace: http://sdtool-be-creation-wizard-api.<YOUR_NAMESPACE>.svc.cluster.local:8080 
  - id: sdtooling-be
    uri: http://sdtool-be-creation-wizard-api.gaiax-edc-dev-sd.svc.cluster.local:8080
    predicates:
      - Path=/*/sdtooling-api/**
    filters:
      - StripPrefix=2
```

Configure the SD Tooling FE to call sd-tooling-be using /private/sdtooling-api/... after the Tier1 Gateway public domain.

## SD Tooling Installation

1) Inside Gitlab project [**sd-tooling-api-be**] is present Helm Chart containing templates and values files. The values.yaml file in this repo are referred to dev env.

2) Configure the ArgoCD manifest to fetch the chart from the PackageRegistry generated by the GitLab pipeline (version 0.1.0)
3) Within the manifest, link an additional repo that points to the values.yaml file located in the Charts repo (https://code.europa.eu/simpl/simpl-open/development/data1/charts) on the feature/release-R0.1S4-RC1 branch.

4) Check and modify the configuration inside Helm **values.yml** file

## Helm Values configuration

```yaml
# service port of component SD-Tooling-Api-Validation
creationWizardApiValidationServicePort: 8080
# service port of component SD-Tooling-Api-Be
creationWizardApiServicePort: 8080
# service port of component SD-Tooling-Frontend-Wizard
creationWizardFrontendServicePort: 8080

# container port of component SD-Tooling-Api-Validation
creationWizardApiValidationContainerPort: 8080
# container port of component SD-Tooling-Api-Be
creationWizardApiContainerPort: 8080
# container port of component SD-Tooling-Frontend-Wizard
creationWizardFrontendContainerPort: 80

# specify 'dev' for dev environment or 'dev-int' for integration environment
vaultEnvIdentifier: dev

# domain associated with Dev Cluster (change with correct value -> int.simpl-europe.eu)
domain: dev.simpl-europe.eu

# ID of persistentVolumeClaims associated with NFS Storage (change it after creation of NFS PersistentVolume and PersistenVolumeClaims)
schemaVolumeClaim: nfs-storage-pvc
# mount path used for schema storage
schemaPvcMountPath: /data

# configuration for connectivity between SD-Tooling-Api-Be and SD-Tooling-Api-Validation
validation:
  config:
    enabled: true
    # domain is the URL of SD-Tooling-Api-Validation service 
    # (sd-creation-wizard-api-validation is name of Kube service associated. Check it!)
    domain: "http://sd-creation-wizard-api-validation:{{ .Values.app.creationWizardApiValidationServicePort }}"
    # name of Validation API Method
    validationApi: "/validate-ttl"
    validationJsonldApi: "/validate-jsonld"

web:
  mvc:
    cors:
      # optional allowed origins for cross calls (list separed by comma or * to allow all origins)
      # if empty no cross calls are allowed
      allowedOrigins: ""
      
    bearerToken:
      # if true a JWT token must be present as Bearer in any request  
      required: true
      
edcConnector:
  # url to the EDC connector domain
  baseUrl: https://edc-provider.dev.simpl-europe.eu
  # the participant id to be used as assigner in policies as expected by the EDC connector on contract negotiation
  participantId: provider


# federated catalog application (fc-service)
federatedCatalogue:
  tier2Gateway:
    # URI to the tier2 tls gateway of the federated catalog application
    uri: https://91.134.104.42
    # tier2 tls gateway path configured as route rule to the federated catalog application
    pathPrefix: /mtls/fc-service


# participant provider
participant:
  onboarding:
    # onboarding authority URI
    authorityTLSUri: https://tls.authority.dev.simpl-europe.eu


# url to the Users&Roles service through the tier1 gateway
usersRoles:
  apiUrl: https://tier1-gateway.gaiax-edc-dev-sd.dev.simpl-europe.eu/private/user-api

# url to the AuthenticationProvider internal service 
authenticationProvider:
  apiUrl: http://authentication-provider:8080

  
# configuration for generating hash values
hash:
  config:
    algorithm: "SHA256"
    templates: '[
                  {
                    "key": "Contract Template 1",
                    "value": "https://files.dev.simpleurope.eu/static/pdf/ContractTemplate1.pdf"
                  },
                  {
                    "key": "Billing Schema 1",
                    "value": "https://files.dev.simpleurope.eu/static/pdf/BillingSchema1.pdf"
                  },
                  {
                    "key": "Sla Agreements 1",
                    "value": "https://files.dev.simpleurope.eu/static/pdf/SLAAgreement1.pdf"
                  },
                  {
                    "key": "Contract Template 2",
                    "value": "https://files.dev.simpleurope.eu/static/pdf/ContractTemplate2.pdf"
                  },
                  {
                    "key": "Billing Schema 2",
                    "value": "https://files.dev.simpleurope.eu/static/pdf/BillingSchema2.pdf"
                  },
                  {
                    "key": "Sla Agreements 2",
                    "value": "https://files.dev.simpleurope.eu/static/pdf/SLAAgreement2.pdf"
                  },
                  {
                    "key": "Contract Template 3",
                    "value": "https://files.dev.simpleurope.eu/static/pdf/ContractTemplate1.pdf"
                  },
                  {
                    "key": "Billing Schema 3",
                    "value": "https://files.dev.simpleurope.eu/static/pdf/BillingSchema1.pdf"
                  },
                  {
                    "key": "Sla Agreements 3",
                    "value": "https://files.dev.simpleurope.eu/static/pdf/SLAAgreement1.pdf"
                  }
                ]'
    models: '[
                {
                  "hashObj": "contractTemplate",
                  "hashDoc": "contractTemplateDocument",
                  "hashAlg": "contractTemplateHashAlg",
                  "hashValue": "contractTemplateHashValue",
                  "hashUrl": "contractTemplateURL"
                },
                {
                  "hashObj": "billingSchema",
                  "hashDoc": "billingSchemaDocument",
                  "hashAlg": "billingSchemaHashAlg",
                  "hashValue": "billingSchemaHashValue",
                  "hashUrl": "billingSchemaURL"
                },
                {
                  "hashObj": "slaAgreements",
                  "hashDoc": "slaAgreementsDocument",
                  "hashAlg": "slaAgreementsHashAlg",
                  "hashValue": "slaAgreementsHashValue",
                  "hashUrl": "slaAgreementsURL"
                }
              ]'
    
#Configure values of offering type based on shape files name
offering-type:
  config:
    templates: '[
                  {
                    "key": "application-offeringShape",
                    "value": "application"
                  },
                  {
                    "key": "data-offeringShape",
                    "value": "data"
                  },
                  {
                    "key": "infrastructure-offeringShape",
                    "value": "infrastructure"
                  }
                ]'


```

1) Go inside Vault and configure variable API_URL with the value "https://creation-wizard-api.int.simpl-europe.eu"

# Self-Description Creation UI

This application allows users to create self-descriptions and publish them to the catalogue. There are multiple types of self-descriptions, each defined by a schema. The application retrieves the available schemas from the self-description creation backend, displays all the fields defined in the schema, and applies every validation rule from it.

After filling out the form, the creation process is performed in the background through the following steps:
1. **Enrichment and validation**
2. **Signing**
3. **Publishing to the catalogue**

> **Note**: To use this application, you must log in with a user that has the `SD_PUBLISHER` permission.

---

## Usage

The application in the development environment is available at:  
[https://sd-ui.dev.simpl-europe.eu/](https://sd-ui.dev.simpl-europe.eu/)

### Login
When opening the application, you will be automatically redirected to the login page:

![Login Screen](images/login_image.png)

---

### Main Screen
After logging in, you'll see the main screen with a dropdown to select schema categories:

![Main Screen](images/main_screen_image.png)

---

### Selecting a Schema
1. **Choose your preferred schema category**:
    - Currently, only the **"Service"** category has implemented functionality.
    - The **"Contract"** category will display a form but will show an error upon submission.

2. **Service Category**:  
   Inside this category, you can select from available schemas. Currently, **Data Offerings** and **Infrastructure Offerings** provide complete functionality.

![Selecting_Schema](images/selecting_schema.png)

#### Data Offerings Example
- Select the `data-offeringShape.ttl` option.
- Fill out all fields with the desired values.
    - Fields with validation rules will display errors if the input is invalid.
    - The form can only be submitted if all fields are valid.
- Fields marked with an asterisk (`*`) are mandatory.

---

### Known Issues
1. **Simpl Target Users**:
    - Leave this field empty; otherwise, the creation process will fail.
    - **Bug Ticket**: `SIMPL-8575`

    ![Simpl Target Users](images/simpl_target_users.png)

2. **Simpl Provider Data Address**:
    - This field requires a valid JSON format, but the UI does not validate it properly.
    - Use a valid Amazon S3 storage bucket address.
    - **Example**:
      ```json
      {
        "type": "IonosS3",
        "region": "de",
        "storage": "s3-eu-central-1.ionoscloud.com",
        "bucketName": "simpl-provider",
        "blobName": "european_health_data.csv",
        "accessKey": "",
        "secretKey": "",
        "keyName": "test-key-name"
      }
      ```

    ![Simpl Provider Data Address](images/simpl_provider_data_address.png)

---

### Access Policies
Define access policies to determine who can access the offering.
- **At least one policy is required.**
- Recommended setup:
    - Assign the `"consume"` action to the `"CONSUMER"` attribute.
    - Without this policy, the offering will not appear in the catalogue.
- Optionally, set a **valid from** and **valid to** date/time to restrict access to a specific timeframe.

![Access Policies](images/access_policies_1.png)

![Access Policies](images/access_policies_2.png)

---

### Usage Policies
Define how the offering can be used within the **Usage Policy** section.

![Usage Policies](images/usage_policies.png)

---

### Submission
- Once all fields are correctly filled out, the **"Submit"** button will become active.
- Clicking **Submit** initiates the multistep creation process:
    1. Enrichment and validation
    2. Signing
    3. Publishing to the catalogue

![Submission](images/submission.png)

---

### Success Message
If the creation process completes successfully, you will see the following message:

![Success Message](images/success_message_image.png)

---

### Error Handling
In case of issues, a red error message will appear instead of the success message.  
Review the error message and adjust the form inputs accordingly.

---

